<?php 

	/*
Plugin Name: Buzer Gesetze verlinken
Plugin URI: http://www.buzer.de/li.htm
Description: verlinkt im Text zitierte Gesetzesverweise und EU-Normen
Author: www.buzer.de
Version: 1.03
Author URI: http://www.buzer.de/
*/

class clsBuzer {

	var $done = 0;

	var $buzer_config = array (
	
		'version' => '1.03',	

		# beliebige Anzahl Attribute zur Linkformatierung des Titels 
		# z.B. 'at'=>'target="_blank"' erzeugt Links wie <a href="ziel" target="_blank">...
		# kann beispielsweise auch fr die Formatierung (style, class, etc.) 
		# oder auch zum Plazieren von Skripten verwendet werden
		'at' 	=> 'target="_blank"',
		
		# analog zu 'at' nur die verlinkten Paragraphen/Artikel betreffend
		'ap'	=> 'target="_blank"',

		#  Zitierrichtung, Standand ist  1 der ZPO, d.h. der Titel wird rechts 
		# vom Paragraphen erwartet, dann ist hier keine Angabe notwendig, 
		# wird z.B. ZPO  1, 2, 3 etc. verwendet, funktioniert das Verlinken 
		# nur wenn das Flag 'lr' gesetz ist, z.B. 'lr' => 1
		'lr'	=> 0,
		
		# beeinflusst die Art der Verlinkung, fr Wordpress keine Angabe 
		# erforderlich, d.h. direkte Verlinkung per html ("<a href ...></a>")
		'type'	=> 0,

		# falls true, werden die Titel selbst nicht verlinkt, also 
		# z.B. bei  1 BGB wird nur der  1 verlinkt, allerdings 
		#erhlt dann natrlich auch "die Vorschriften des BGB bestimmen" keinen Link
		'not'	=> 0,
		
		# kommaseparierte Liste von Titeln, die mit diesem Titel nie verlinkt werden
		# WEG meint hfiger den Weg als das WEG, ALG ist oft ALG II
		'notitle' => 'WEG,ALG,WHG,LAG,FANG,AUG',
		
		# falls true, werden Sonderzeichen html-codiert
		'esc'	=> 0,
		
		# ersetzt aufeinanderfolgende Leerzeichen durch eines, 
		# fhrt zu besseren Ergebnissen, 
		# falls Text stark durch Verwendung von Leerzeichen formatiert ist, 
		# zerstrt dann allerdings auch diese Formatierung
		'trim'	=> 0,
		
		# fhrt ein Text lediglich Paragraphen auf aber nie den Titel selbst, 
		# weil klar ist, von welchem Titel die Rede ist,  wird auch keine Verlinkung 
		# erfolgen, weil das Plugin den Titel eben nicht kennt, hier hat man die Mglichkeit
		# einen Standardtitel anzugeben, z.B. 'dg'='EStG', wenn von eben diesem die 
		# Rede ist und im nheren Umfeld kein Titel gefunden wird 
		# ABER: da kaum in allen Artike immer die Rede vom EStG sein wird, 
		# macht eine Angabe hier im Plugin selten Sinn
		'dg'	=> '',
		
		# Zieladresse fr Postheader
		'_post'		=> '/li.htm',

		# Servername
		'_host'	=> 'www.buzer.de',
		
		# Port
		'_port'		=> 80,
		
		# timeout fr Verbindung zu buzer.de in Sekunden, falls berschritten 
		# wird der Eingangstext zurckgegeben
		'_timeout'	=> 5,
		
		# false hier eine Angabe erfolgt, wird eine Tabelle dieses Namens
		# als Cache verwendet
		# bei Angabe erfolgt die Verlinkung bei Anzeige des Artikels
		# wenn leer, wird der Artikel beim Speichern in der Datenbank verlinkt
		'_cache'	=> 'buzer_cache',
		
		# Debug falls true
		'_debug'	=> 0,
		
	);

	function clsBuzer() {
		return $this;
	}


	function buzer_getCache( $config, $text, $id) {
		# gibt falls vorhandenen den cache zurck
		$result = WCF::getDB()->getFirstRow( "select cache from ".$config['_cache']." 
			where id=0$id and hash = md5('".mysql_escape_string($text)."') and charset='".mysql_escape_string($config['charset'])."' 
			limit 1;");
		return $result['cache'] == "1" ? $text : $result['cache'];
	}

	function buzer_insertCache( $config, $text, $cache, $id) {
		# schreibt die verlinkte version in den cache
		
		$sql = "update ".$config['_cache']."
			set cache=convert('".mysql_escape_string($text." "==$cache?1:$cache)."' using latin1), 				
			dateupdate=now(), 
			hash=md5('".mysql_escape_string($text)."'), 
			charset='".mysql_escape_string($config['charset'])."'
			where id=0$id";

		if ( WCF::getDB()->sendQuery( $sql) and WCF::getDB()->getAffectedRows() ) {
			return 1;
		}
		
		$sql = "insert ignore into ".$config['_cache']." 
			(cache, hash, charset, dateinsert, id) 
			values (convert('".mysql_escape_string($text." "==$cache?1:$cache)."' using latin1), 
			md5('".mysql_escape_string($text)."')
			, '".mysql_escape_string($config['charset'])."', now(), 0$id)";
		return WCF::getDB()->sendQuery( $sql );

	}

	function buzer_LinkIt($textin, $charset, $id) {
		# verlinkt den bergebenen text
		$buzer_config=$this->buzer_config;
		
		if ( strlen($charset)>0 ) {
			$buzer_config['charset']=$charset;
		}
		
		if ( $cache=$this->buzer_getCache( $buzer_config, $textin, $id) ) { return $cache; }	

		if ( $this->done ) {
			return $textin;
		}		
		
		# maximal ein request pro Seitenabruf
		$this->done = 1;
		
		$content = 'plugin=wbb&site='.urlencode($_SERVER['HTTP_HOST']); 
		
		foreach ($buzer_config as $key => $value) {
			if ( $value && !preg_match('/^_/', $key )) {
				$content .= "&$key=" . urlencode( $value );
			}
		}
		
		$content .= "&text=" . urlencode($textin);
		
		$header = "POST ".$buzer_config['_post']." HTTP/1.0\n";
		$header .= "Host: ".$buzer_config['_host']."\n";
		$header .= "Content-type: application/x-www-form-urlencoded; charset=" . urlencode($buzer_config['charset']) ."\n";
		$header .= "Content-length: " . strlen($content) . "\n\n";
		
		if ( $buzer_config['_debug']) echo "header=$header<br />";
		
		$socket = fsockopen($buzer_config['_host'], $buzer_config['_port'], $errno, $errstr, $buzer_config['_timeout']);
		
		if ( $buzer_config['_debug']) echo "fsockopen: socket=$socket, errno=$errno, errstr=$errstr<br />";
		
		if ( !$socket ) return $textin;
		
		if ( $buzer_config['_debug']) echo "Content: $content<br />";

		socket_set_timeout($socket, $buzer_config['_timeout'], 0);
		socket_set_blocking($socket, true);
		fputs($socket, $header.$content);
		$timed_out = false;
		$eof = false;
		$textout='';
		while (!$eof and !$timed_out) {
			$textout.= fgets($socket, 1024);
			$state = socket_get_status($socket);
			$eof = $state['eof'];
			$timed_out = $state['timed_out'];
		}
		fclose($socket);
		if ( $buzer_config['_debug']) echo "length: ".strlen($textout)."<br />";
		
		$cmd = substr( $textout, -100);
		if ( substr($cmd, 0, 2) != "OK" ) {
			return $textin;
		}
		$textout = substr( $textout, 0, -100);		
		
		$del = "\n";
		if ( preg_match("/\r\n/", $textout) ) { $del="\r\n"; }
		
		$ok = false;
		$lines = explode($del, $textout);
		$i = 0;
		while ( $_ = $lines[$i++] ) {
			if ( preg_match('/200 OK/', $_) ) {
				$ok = true;
			}
		}
		
		if ( $buzer_config['_debug']) echo "read: ok=$ok, textout=$textout<br />";
		
		if ( !$ok ) {
			return $textin;
		}	
		
		$textout = implode($del, array_slice( $lines, $i));
		if ( $textin and strlen($textout)<strlen($textin) ) {
			if ( $buzer_config['_debug']) echo "Break zu kurz<br />";
			return $textin;
		} 

		
		$this->buzer_insertCache( $buzer_config, $textin, $textout, $id);
		return $textout;

	}
	
}

$gBuzer = new clsBuzer();


?>